mysite/enquetes/urls.py
from django.urls import path
from . import views

app_name = 'enquetes'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path('detalhes/<int:pk>/',
        views.DetalhesView.as_view(), name='detalhes'
    ),
    path('resultado/<int:pk>/',
        views.ResultadoView.as_view(), name='resultado'
    ),
    path('votacao/<int:pk>/',
        views.VotacaoView.as_view(), name='votacao'
    ),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('raiz.urls')),
    path('enquetes/', include('enquetes.urls')),
    path('forum/', include('forum.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/raiz/urls.py
from django.urls import path
from . import views

app_name = 'raiz'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
]

mysite/enquetes/models.py
import datetime
from django.db import models
from django.utils import timezone
from forum.models import Usuario

class Pergunta(models.Model):
    texto = models.CharField(max_length = 150)
    data_pub = models.DateTimeField('Data de Publicação')
    autor = models.ForeignKey(
        Usuario, related_name = 'autor',
        on_delete = models.CASCADE, null = True
    )
    def __str__(self):
        return '({}) - {}'.format(self.id, self.texto)
    def foi_publicada_recentemente(self):
        agora = timezone.now()
        return agora-datetime.timedelta(days=1) <= self.data_pub <= agora
    foi_publicada_recentemente.admin_order_field = 'data_pub'
    foi_publicada_recentemente.boolean = True
    foi_publicada_recentemente.short_description = 'É Recente?'

class Alternativa(models.Model):
    texto = models.CharField(max_length = 80)
    quant_votos = models.IntegerField('Quantidade de Votos', default = 0)
    pergunta = models.ForeignKey(Pergunta, on_delete = models.CASCADE)
    def __str__(self):
        return '({}) - {}'.format(self.id, self.texto)

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.utils import timezone
from django.http import HttpResponseRedirect, Http404
from django.urls import reverse
from django.views import View
from .models import Pergunta, Alternativa

class IndexView(View):
    def get(self, request, *args, **kwargs):
        lista_enquetes = Pergunta.objects.filter(
            data_pub__lte = timezone.now()
        ).order_by('-data_pub')
        contexto = { 'lista_enquetes': lista_enquetes }
        return render(request, 'enquetes/index.html', contexto)

class DetalhesView(View):
    def get(self, request, *args, **kwargs):
        pergunta = get_object_or_404(Pergunta, pk = kwargs['pk'])
        if pergunta.data_pub >= timezone.now():
            raise Http404('Nenhuma Enquete publicada com essa identificação')
        return render(
            request, 'enquetes/detalhes.html',
            {'pergunta': pergunta}
        )

class ResultadoView(View):
    def get(self, request, *args, **kwargs):
        pergunta = get_object_or_404(Pergunta, pk = kwargs['pk'])
        return render(
            request, 'enquetes/resultado.html',
            {'pergunta': pergunta}
        )

class VotacaoView(View):
    def post(self, request, *args, **kwargs):
        pergunta = get_object_or_404(Pergunta, pk = kwargs['pk'])
        try:
            alt_id = request.POST['alt']
            alternativa = pergunta.alternativa_set.get(pk=alt_id)
        except(KeyError, Alternativa.DoesNotExist):
            return render(request, 'enquetes/detalhes.html', {
                'pergunta': pergunta,
                'error': 'Selecione uma alternativa válida!'
            })
        else:
            alternativa.quant_votos += 1
            alternativa.save()
            return HttpResponseRedirect(reverse(
                'enquetes:resultado', args=(pergunta.id,)
            ))


"""
#### HISTÓRICO DAS VERSÕES ####
###############################

## VIEW INDEX ##
################
----versão 1
    resultado = ',<br/> '.join([p.texto for p in lista_enquetes])
    return HttpResponse(resultado)
----versão 2
    template = loader.get_template('enquetes/index.html')
    return HttpResponse(template.render(contexto, request))
----versão 3
def index(request):
    lista_enquetes = Pergunta.objects.order_by('-data_pub')[:10]
    contexto = { 'lista_enquetes': lista_enquetes }
    return render(request, 'enquetes/index.html', contexto)
----vesão 4
class IndexView(generic.ListView):
    template_name = 'enquetes/index.html'
    context_object_name = 'lista_enquetes'
    def get_queryset(self):
        return Pergunta.objects.order_by('-data_pub')

## VIEW DETALHES ##
###################
----versão 1
    retorno = "<h2>DETALHES da enquete de identificador = %s</h2>"
    return HttpResponse(retorno % enquete_id)
----versão 2
    try:
        pergunta = Pergunta.objects.get(pk = enquete_id)
    except Pergunta.DoesNotExist:
        raise Http404("Identificador de enquete inválido!")
----versão 3
def detalhes(request, enquete_id):
    pergunta = get_object_or_404(Pergunta, pk = enquete_id)
    return render(
        request, 'enquetes/detalhes.html', {'pergunta': pergunta}
    )
----versão 4
class DetalhesView(generic.DetailView):
    model = Pergunta
    template_name = 'enquetes/detalhes.html'
## VIEW RESULTADO ##
####################
----versão 1
def resultado(request, enquete_id):
    pergunta = get_object_or_404(Pergunta, pk = enquete_id)
    return render(
        request, 'enquetes/resultado.html', {'pergunta': pergunta}
    )
----versão 2
class ResultadoView(generic.DetailView):
    model = Pergunta
    template_name = 'enquetes/resultado.html'
## VIEW VOTACAO ##
##################
----versão 1
def votacao(request, enquete_id):
    pergunta = get_object_or_404(Pergunta, pk = enquete_id)
    try:
        alt_id = request.POST['alt']
        alternativa = pergunta.alternativa_set.get(pk=alt_id)
    except(KeyError, Alternativa.DoesNotExist):
        return render(request, 'enquetes/detalhes.html', {
            'pergunta': pergunta,
            'error': 'Selecione uma alternativa válida!'
        })
    else:
        alternativa.quant_votos += 1
        alternativa.save()
        return HttpResponseRedirect(reverse(
            'enquetes:resultado', args=(pergunta.id,)
        ))
"""

mysite/enquetes/templates/enquetes/base.html
{% load static %}

<html>
    <head>
        <title>{% block titulo %}App Enquetes{% endblock %}</title>
        {% block estilo %}
        <link rel="stylesheet" type="text/css"
              href="{% static 'enquetes/css/style.css' %}" />
        {% endblock %}
    </head>
    <body>
        <h1>{% block h1 %}Aplicação de Enquetes{% endblock %}</h1>
        {% block logo %}
        <img src="{% static 'enquetes/img/principal.jpg' %}" width="180"/>
        {% endblock %}
        <h2>{% block h2%}Lista das Enquetes Cadastradas:{% endblock %}</h2>

        {% block conteudo %}{% endblock %}

        <hr/>
        {% block menu %}
        <a href="{% url 'raiz:index' %}">Raiz Projeto</a>
        | <a href="{% url 'enquetes:index' %}">Enquetes : principal</a>
        {% endblock %}
    </body>
</html>

mysite/enquetes/templates/enquetes/detalhes.html
{% extends 'enquetes/base.html' %}

{% block logo %}{% endblock %}

{% block h2 %}Detalhes da Enquete #{{ pergunta.id }}{% endblock %}

{% block conteudo %}
    <h3>{{ pergunta.texto }}</h3>
    Escolha a alternativa desejada:<br/>
    {% if error %}
    <h3>{{ error }}</h3>
    {% endif %}
    <form action="{% url 'enquetes:votacao' pergunta.id %}"
          method="post">
        {% csrf_token %}
        <ul>
        {% for alt in pergunta.alternativa_set.all %}
            <li>
                <input type="radio" name="alt" value="{{ alt.id }}"
                       id="alt{{ forloop.counter }}" />
                <label for="alt{{ forloop.counter }}">
                    {{ alt.texto }}
                </label>
            </li>
        {% endfor %}
        </ul>
        <input type="submit" value="Registre o seu voto">
    </form>
{% endblock %}

mysite/enquetes/templates/enquetes/index.html
{% extends 'enquetes/base.html' %}
{% load static %}

{% block conteudo %}
    {% if lista_enquetes %}
        <ul>
            {% for pergunta in lista_enquetes %}
                <li><a href="{% url 'enquetes:detalhes' pergunta.id %}">
                    {{ pergunta.texto }}</a>
                &nbsp;(<a href="{% url 'enquetes:resultado' pergunta.id %}">
                    ver parcial</a>)</li>
            {% endfor %}
        </ul>
    {% else %}
        <h3>Não existem enquetes cadastradas até o momento.</h3>
    {% endif %}
{% endblock %}

mysite/enquetes/templates/enquetes/resultado.html
{% extends 'enquetes/base.html' %}

{% block h2 %}RESULTADO Parcial da Enquete #{{ pergunta.id }}{% endblock %}

{% block conteudo %}
    <h3>{{ pergunta.texto }}</h3>
    <ul>
    {% for alt in pergunta.alternativa_set.all %}
        <li>{{ alt.texto }} = {{ alt.quant_votos }}
            voto{{ alt.quant_votos | pluralize }}
        </li>
    {% endfor %}
    </ul>
{% endblock %}

{% block menu %}
    {{ block.super }}
    | <a href="{% url 'enquetes:detalhes' pergunta.id %}">Votar novamente?</a>
{% endblock %}